--[[--------------------------------------------------------------------------------
Copyright (c) Ulf Dornheck Busscher (Duugu) <duugu@duugu.com>
All rights reserved.
----------------------------------------------------------------------------------

HOW TO USE:

Loading the API in your addon:
	local BAB = LibStub("BAB")

FUNCTION LIST:

SaveProfile()
	Saves the current used BAB profile

GetSettings()
	Returns the global settings as a table

GetBar(<string>BarName)
	Returns the bar data as a table
------------------------------------------------
]]


BABAURAS_MAJOR_VERSION, BABAURAS_MINOR_VERSION = string.match(GetAddOnMetadata("BABAuras", "Version"), "(%d+%.%d+)%.(%d+)")
local _, BAB = ...
local API, oldversion = LibStub:NewLibrary("BABAuras-"..BABAURAS_MAJOR_VERSION, BABAURAS_MINOR_VERSION)

---
function API:GetSettings()
	return BAB.DB.Settings
end
---
function API:GetBar(pBarname)
	if not BAB.DB.Bars[pBarname] then return end
	return BAB.DB.Bars[pBarname]
end
---
function API:SaveProfile()
	BAB:SaveProfile()
end
