local _, BAB = ...

---
function BAB:UpdateAuras()
	BAB:UnitAuraTableUpdate()
	local tEnchants = {
		[16] = false,	--Main hand
		[17] = false,	--Off-hand
		[18] = false,	--range?
	}

	local name, rank, texture, count, debuffType, duration, expirationTime, caster, isStealable, shouldConsolidate, spellId
	local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges

	if not BAB.DB.CalculatedDirectionButtonTable then BAB:CalculateDirectionButtonTable() end

	--buffs
	for x = 1, BAB.DB.Settings.maxBuffsToQuery do
		if BAB.DB.CalculatedDirectionButtonTable.Buffs[x] then
			local tBar, tX = BAB.DB.CalculatedDirectionButtonTable.Buffs[x].barname, BAB.DB.CalculatedDirectionButtonTable.Buffs[x].buttonnumber
			if BAB.DB.Bars[tBar] then
				name, rank, texture, count, debuffType, duration, expirationTime, caster, isStealable, shouldConsolidate, spellId = BAB:UnitAura("player", x, "HELPFUL")
				local tData = BAB.DB.Bars[tBar].Buttons[tX].AuraData
				tData.index, tData.type, tData.name, tData.rank, tData.texture, tData.count, tData.debuffType, tData.duration, tData.expirationTime, tData.caster, tData.isStealable, tData.shouldConsolidate, tData.spellId = x, "HELPFUL", name, rank, BAB:ModifyTexturePath(texture), count, debuffType, duration, expirationTime, caster, isStealable, shouldConsolidate, spellId
				if tData.texture and tData.texture ~= "" then 
					BAB.DB.Bars[tBar].Buttons[tX].frame.icon:SetTexture(tData.texture) 
					BAB.DB.Bars[tBar].Buttons[tX].frame.icon:Show()
					if tData.expirationTime and tData.expirationTime > 0 then
						BAB.DB.Bars[tBar].Buttons[tX].BABCount.FS:SetText(BAB:FormatTimeValue(math.floor(tData.expirationTime - GetTime())))
						BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = tData.duration
						BAB.DB.Bars[tBar].Buttons[tX].cooldownstart = tData.expirationTime - tData.duration
					else
						BAB.DB.Bars[tBar].Buttons[tX].BABCount.FS:SetText("")
						BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = 0
					end
					if tData.count and tData.count > 1 then
						BAB.DB.Bars[tBar].Buttons[tX].BABHotKey.FS:SetText(tData.count)
					else
						BAB.DB.Bars[tBar].Buttons[tX].BABHotKey.FS:SetText("")
					end
				else
					BAB.DB.Bars[tBar].Buttons[tX].frame.icon:SetTexture("") 
					BAB.DB.Bars[tBar].Buttons[tX].frame.icon:Hide()
					BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = 0
				end
			end
		end
	end
	--debuffs
	for x = 1, BAB.DB.Settings.maxDebuffsToQuery do
		if BAB.DB.CalculatedDirectionButtonTable.Debuffs[x] then
			local tBar, tX = BAB.DB.CalculatedDirectionButtonTable.Debuffs[x].barname, BAB.DB.CalculatedDirectionButtonTable.Debuffs[x].buttonnumber
			if BAB.DB.Bars[tBar] then
				name, rank, texture, count, debuffType, duration, expirationTime, caster, isStealable, shouldConsolidate, spellId = BAB:UnitAura("player", x, "HARMFUL")
				local tData = BAB.DB.Bars[tBar].Buttons[tX].AuraData
				tData.index, tData.type, tData.name, tData.rank, tData.texture, tData.count, tData.debuffType, tData.duration, tData.expirationTime, tData.caster, tData.isStealable, tData.shouldConsolidate, tData.spellId = x, "HARMFUL", name, rank, BAB:ModifyTexturePath(texture), count, debuffType, duration, expirationTime, caster, isStealable, shouldConsolidate, spellId
				if tData.texture and tData.texture ~= "" then 
					BAB.DB.Bars[tBar].Buttons[tX].frame.icon:SetTexture(tData.texture) 
					BAB.DB.Bars[tBar].Buttons[tX].frame.icon:Show()
					if tData.expirationTime and tData.expirationTime > 0 then
						BAB.DB.Bars[tBar].Buttons[tX].BABCount.FS:SetText(BAB:FormatTimeValue(math.floor(tData.expirationTime - GetTime())))
						BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = tData.duration
						BAB.DB.Bars[tBar].Buttons[tX].cooldownstart = tData.expirationTime - tData.duration
					else
						BAB.DB.Bars[tBar].Buttons[tX].BABCount.FS:SetText("")
						BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = 0
					end
					if tData.count and tData.count > 1 then
						BAB.DB.Bars[tBar].Buttons[tX].BABHotKey.FS:SetText(tData.count)
					else
						BAB.DB.Bars[tBar].Buttons[tX].BABHotKey.FS:SetText("")
					end
				else
					BAB.DB.Bars[tBar].Buttons[tX].frame.icon:SetTexture("") 
					BAB.DB.Bars[tBar].Buttons[tX].frame.icon:Hide()
					BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = 0
				end
			end
		end

	end

	--enchants
	if BAB.DB.CalculatedDirectionButtonTable.Enchants[1] then
		local hasMainHandEnchant, mainHandExpiration, mainHandCharges, _, hasOffHandEnchant, offHandExpiration, offHandCharges  = GetWeaponEnchantInfo()
		local tCounter = 1

		local tBar, tX = BAB.DB.CalculatedDirectionButtonTable.Enchants[tCounter].barname, BAB.DB.CalculatedDirectionButtonTable.Enchants[tCounter].buttonnumber
		local tData = BAB.DB.Bars[tBar].Buttons[tX].AuraData
		if not mainHandExpiration then mainHandExpiration = 0 end

		if hasMainHandEnchant and GetInventorySlotInfo("MainHandSlot") then
			name, rank, texture, count, debuffType, expirationTime, caster, isStealable, shouldConsolidate, spellId = "MH", 1, "", mainHandCharges, nil, math.floor(mainHandExpiration / 1000), "player", false, false, GetInventoryItemID("player", INVSLOT_MAINHAND)
			texture = GetInventoryItemTexture("player", INVSLOT_MAINHAND)
			tData.index, tData.type, tData.name, tData.rank, tData.texture, tData.count, tData.debuffType, tData.expirationTime, tData.caster, tData.isStealable, tData.shouldConsolidate, tData.spellId = x, "MH", name, rank, BAB:ModifyTexturePath(texture), count, debuffType, GetTime() + expirationTime, caster, isStealable, shouldConsolidate, spellId

			--if hasMainHandEnchant ~= true then
				tData.duration = mainHandExpiration - GetTime()
				if tData.duration < 0 then tData.duration = 0 end
			--end

			if tData.texture and tData.texture ~= "" then 
				BAB.DB.Bars[tBar].Buttons[tX].frame.icon:SetTexture(tData.texture) 
				BAB.DB.Bars[tBar].Buttons[tX].frame.icon:Show()
				if tData.expirationTime and tData.expirationTime > 0 then
					BAB.DB.Bars[tBar].Buttons[tX].BABCount.FS:SetText(BAB:FormatTimeValue(math.floor(tData.expirationTime - GetTime())))
					BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = tData.duration
					BAB.DB.Bars[tBar].Buttons[tX].cooldownstart = tData.expirationTime - tData.duration
				else
					BAB.DB.Bars[tBar].Buttons[tX].BABCount.FS:SetText("")
					BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = 0
				end
				if tData.count and tData.count > 1 then
					BAB.DB.Bars[tBar].Buttons[tX].BABHotKey.FS:SetText(tData.count)
				else
					BAB.DB.Bars[tBar].Buttons[tX].BABHotKey.FS:SetText("")
				end
			else
				BAB.DB.Bars[tBar].Buttons[tX].frame.icon:SetTexture("") 
				BAB.DB.Bars[tBar].Buttons[tX].frame.icon:Hide()
				BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = 0
			end
		else
			BAB.DB.Bars[tBar].Buttons[tX].frame.icon:SetTexture("") 
			BAB.DB.Bars[tBar].Buttons[tX].frame.icon:Hide()
			BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = 0
			tData.spellId = nil
			tData.duration = nil
		end		
		tCounter = tCounter + 1

		local tBar, tX = BAB.DB.CalculatedDirectionButtonTable.Enchants[tCounter].barname, BAB.DB.CalculatedDirectionButtonTable.Enchants[tCounter].buttonnumber
		local tData = BAB.DB.Bars[tBar].Buttons[tX].AuraData
		if not offHandExpiration then offHandExpiration = 0 end

		if hasOffHandEnchant and (hasOffHandEnchant ~= 0)  and GetInventorySlotInfo("SecondaryHandSlot") then
			name, rank, texture, count, debuffType, expirationTime, caster, isStealable, shouldConsolidate, spellId = "OH", 1, "", offHandCharges, nil, math.floor(offHandExpiration / 1000), "player", false, false, GetInventoryItemID("player", INVSLOT_OFFHAND)
			texture = GetInventoryItemTexture("player", INVSLOT_OFFHAND)
			tData.index, tData.type, tData.name, tData.rank, tData.texture, tData.count, tData.debuffType, tData.expirationTime, tData.caster, tData.isStealable, tData.shouldConsolidate, tData.spellId = x, "OH", name, rank, BAB:ModifyTexturePath(texture), count, debuffType, GetTime() + expirationTime, caster, isStealable, shouldConsolidate, spellId

			tData.duration = offHandExpiration - GetTime()
			if tData.duration < 0 then tData.duration = 0 end

			if tData.texture and tData.texture ~= "" then 
				BAB.DB.Bars[tBar].Buttons[tX].frame.icon:SetTexture(tData.texture) 
				BAB.DB.Bars[tBar].Buttons[tX].frame.icon:Show()
				if tData.expirationTime and tData.expirationTime > 0 then
					BAB.DB.Bars[tBar].Buttons[tX].BABCount.FS:SetText(BAB:FormatTimeValue(math.floor(tData.expirationTime - GetTime())))
					BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = tData.duration
					BAB.DB.Bars[tBar].Buttons[tX].cooldownstart = tData.expirationTime - tData.duration
				else
					BAB.DB.Bars[tBar].Buttons[tX].BABCount.FS:SetText("")
					BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = 0
					tData.duration = 0
				end
				if tData.count and tData.count > 1 then
					BAB.DB.Bars[tBar].Buttons[tX].BABHotKey.FS:SetText(tData.count)
				else
					BAB.DB.Bars[tBar].Buttons[tX].BABHotKey.FS:SetText("")
				end
			else
				BAB.DB.Bars[tBar].Buttons[tX].frame.icon:SetTexture("") 
				BAB.DB.Bars[tBar].Buttons[tX].frame.icon:Hide()
				BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = 0
				tData.duration = 0
			end
		else
			BAB.DB.Bars[tBar].Buttons[tX].frame.icon:SetTexture("") 
			BAB.DB.Bars[tBar].Buttons[tX].frame.icon:Hide()
			BAB.DB.Bars[tBar].Buttons[tX].cooldownDuration = 0
			tData.spellId = nil
			tData.duration = nil
		end	
		tCounter = tCounter + 1
	end

	--[[
	for ibar, vbar in pairs(BAB.DB.Bars) do
		for ibut, vbut in pairs(vbar.Buttons) do
			if not (BAB.DB.CancelButton:IsVisible() and InCombatLockdown()) then
				if BAB.DB.Bars[ibar].Buttons[ibut].AuraData.spellId then
					
					BAB.DB.Bars[ibar].Buttons[ibut].frame:EnableMouse(true)

				else
					BAB.DB.Bars[ibar].Buttons[ibut].frame:EnableMouse(false)
				end
			end
		end
	end
	]]

end
---
function BAB:IsAuraCancelable(pSpellID, pType)
	if pType == "MH" or pType == "OH" then return true end
	local name, rank, texture, count, debuffType, duration, expirationTime, caster, isStealable, shouldConsolidate, spellId
	for x = 1, 32 do
		name, rank, texture, count, debuffType, duration, expirationTime, caster, isStealable, shouldConsolidate, spellId = BAB:UnitAura("player", x, pType.."|CANCELABLE")
		if pSpellID == spellId then
			return true
		end
	end
	return false
end
---
function BAB:CalculateDirectionButtonTable()
	BAB.DB.CalculatedDirectionButtonTable = {
		Buffs = {}, 
		Debuffs = {}, 
		Enchants = {}, 
		}

	local tOverallNumberOfButtons = 0
	for x = 1, BAB.DB.GlobalSettings.numberBuffBars do
		tOverallNumberOfButtons = tOverallNumberOfButtons + BAB:GetNumberOfButtons(BAB.L["Buff"].." "..x)
	end

	if tOverallNumberOfButtons > 0 then 

		if BAB.DB.GlobalSettings.BuffFillDirection == 3 then
			local tBtnTable = {}
			local tCount = 1
			for x = 1, BAB.DB.GlobalSettings.numberBuffBars do
				for y = 1, BAB:GetNumberOfButtons(BAB.L["Buff"].." "..x) do
					tBtnTable[tCount] = {barname = BAB.L["Buff"].." "..x, buttonnumber = y}
					tCount = tCount + 1
				end
			end

			if tOverallNumberOfButtons == 1 then
				BAB.DB.CalculatedDirectionButtonTable.Buffs[1] = {barname = tBtnTable[1].barname, buttonnumber = tBtnTable[1].buttonnumber}
			elseif tOverallNumberOfButtons == 2 then
				BAB.DB.CalculatedDirectionButtonTable.Buffs[1] = {barname = tBtnTable[1].barname, buttonnumber = tBtnTable[1].buttonnumber}
				BAB.DB.CalculatedDirectionButtonTable.Buffs[2] = {barname = tBtnTable[2].barname, buttonnumber = tBtnTable[2].buttonnumber}
			elseif tOverallNumberOfButtons == 3 then
				BAB.DB.CalculatedDirectionButtonTable.Buffs[1] = {barname = tBtnTable[2].barname, buttonnumber = tBtnTable[2].buttonnumber}
				BAB.DB.CalculatedDirectionButtonTable.Buffs[2] = {barname = tBtnTable[1].barname, buttonnumber = tBtnTable[1].buttonnumber}
				BAB.DB.CalculatedDirectionButtonTable.Buffs[2] = {barname = tBtnTable[3].barname, buttonnumber = tBtnTable[3].buttonnumber}
			else
				local tCurrent = math.floor(tOverallNumberOfButtons / 2)
				local tModifier = 1
				tCount = 2
				BAB.DB.CalculatedDirectionButtonTable.Buffs[1] = {barname = tBtnTable[tCurrent].barname, buttonnumber = tBtnTable[tCurrent].buttonnumber}
				while tCount <= (tOverallNumberOfButtons) do
					if tBtnTable[tCurrent + tModifier] then
						BAB.DB.CalculatedDirectionButtonTable.Buffs[tCount] = {barname = tBtnTable[tCurrent + tModifier].barname, buttonnumber = tBtnTable[tCurrent + tModifier].buttonnumber}
						tCount = tCount + 1
					end
					if tBtnTable[tCurrent - tModifier] then
						BAB.DB.CalculatedDirectionButtonTable.Buffs[tCount] = {barname = tBtnTable[tCurrent - tModifier].barname, buttonnumber = tBtnTable[tCurrent - tModifier].buttonnumber}
						tCount = tCount + 1
					end
					tModifier = tModifier + 1
				end
			end

		elseif BAB.DB.GlobalSettings.BuffFillDirection == 2 then
			local tCount = 1
			for x = 1, BAB.DB.GlobalSettings.numberBuffBars do
				for y = 1, BAB:GetNumberOfButtons(BAB.L["Buff"].." "..x) do
					BAB.DB.CalculatedDirectionButtonTable.Buffs[tCount] = {barname = BAB.L["Buff"].." "..x, buttonnumber = y}
					tCount = tCount + 1
				end
			end
		else
			local tCount = 1
			for x = BAB.DB.GlobalSettings.numberBuffBars, 1, -1 do
				for y = BAB:GetNumberOfButtons(BAB.L["Buff"].." "..x), 1, -1 do
					BAB.DB.CalculatedDirectionButtonTable.Buffs[tCount] = {barname = BAB.L["Buff"].." "..x, buttonnumber = y}
					tCount = tCount + 1
				end
			end
		end
	end



	tOverallNumberOfButtons = 0
	for x = 1, BAB.DB.GlobalSettings.numberDebuffBars do
		tOverallNumberOfButtons = tOverallNumberOfButtons + BAB:GetNumberOfButtons(BAB.L["Debuff"].." "..x)
	end

	if tOverallNumberOfButtons > 0 then 

		if BAB.DB.GlobalSettings.DebuffFillDirection == 3 then
			local tBtnTable = {}
			local tCount = 1
			for x = 1, BAB.DB.GlobalSettings.numberDebuffBars do
				for y = 1, BAB:GetNumberOfButtons(BAB.L["Debuff"].." "..x) do
					tBtnTable[tCount] = {barname = BAB.L["Debuff"].." "..x, buttonnumber = y}
					tCount = tCount + 1
				end
			end

			if tOverallNumberOfButtons == 1 then
				BAB.DB.CalculatedDirectionButtonTable.Debuffs[1] = {barname = tBtnTable[1].barname, buttonnumber = tBtnTable[1].buttonnumber}
			elseif tOverallNumberOfButtons == 2 then
				BAB.DB.CalculatedDirectionButtonTable.Debuffs[1] = {barname = tBtnTable[1].barname, buttonnumber = tBtnTable[1].buttonnumber}
				BAB.DB.CalculatedDirectionButtonTable.Debuffs[2] = {barname = tBtnTable[2].barname, buttonnumber = tBtnTable[2].buttonnumber}
			elseif tOverallNumberOfButtons == 3 then
				BAB.DB.CalculatedDirectionButtonTable.Debuffs[1] = {barname = tBtnTable[2].barname, buttonnumber = tBtnTable[2].buttonnumber}
				BAB.DB.CalculatedDirectionButtonTable.Debuffs[2] = {barname = tBtnTable[1].barname, buttonnumber = tBtnTable[1].buttonnumber}
				BAB.DB.CalculatedDirectionButtonTable.Debuffs[2] = {barname = tBtnTable[3].barname, buttonnumber = tBtnTable[3].buttonnumber}
			else
				local tCurrent = math.floor(tOverallNumberOfButtons / 2)
				local tModifier = 1
				tCount = 2
				BAB.DB.CalculatedDirectionButtonTable.Debuffs[1] = {barname = tBtnTable[tCurrent].barname, buttonnumber = tBtnTable[tCurrent].buttonnumber}
				while tCount <= (tOverallNumberOfButtons) do
					if tBtnTable[tCurrent + tModifier] then
						BAB.DB.CalculatedDirectionButtonTable.Debuffs[tCount] = {barname = tBtnTable[tCurrent + tModifier].barname, buttonnumber = tBtnTable[tCurrent + tModifier].buttonnumber}
						tCount = tCount + 1
					end
					if tBtnTable[tCurrent - tModifier] then
						BAB.DB.CalculatedDirectionButtonTable.Debuffs[tCount] = {barname = tBtnTable[tCurrent - tModifier].barname, buttonnumber = tBtnTable[tCurrent - tModifier].buttonnumber}
						tCount = tCount + 1
					end
					tModifier = tModifier + 1
				end
			end

		elseif BAB.DB.GlobalSettings.DebuffFillDirection == 2 then
			local tCount = 1
			for x = 1, BAB.DB.GlobalSettings.numberDebuffBars do
				for y = 1, BAB:GetNumberOfButtons(BAB.L["Debuff"].." "..x) do
					BAB.DB.CalculatedDirectionButtonTable.Debuffs[tCount] = {barname = BAB.L["Debuff"].." "..x, buttonnumber = y}
					tCount = tCount + 1
				end
			end
		else
			local tCount = 1
			for x = BAB.DB.GlobalSettings.numberDebuffBars, 1, -1 do
				for y = BAB:GetNumberOfButtons(BAB.L["Debuff"].." "..x), 1, -1 do
					BAB.DB.CalculatedDirectionButtonTable.Debuffs[tCount] = {barname = BAB.L["Debuff"].." "..x, buttonnumber = y}
					tCount = tCount + 1
				end
			end
		end
	end

	--enchants
	if BAB.DB.GlobalSettings.EnchantFillDirection == 1 then
		local tCount = 1
		for y = 1, BAB:GetNumberOfButtons(BAB.L["Enchants"]) do
			BAB.DB.CalculatedDirectionButtonTable.Enchants[tCount] = {barname = BAB.L["Enchants"], buttonnumber = y}
			tCount = tCount + 1
		end
	else
		local tCount = 1
		for y = BAB:GetNumberOfButtons(BAB.L["Enchants"]), 1, -1 do
			BAB.DB.CalculatedDirectionButtonTable.Enchants[tCount] = {barname = BAB.L["Enchants"], buttonnumber = y}
			tCount = tCount + 1
		end
	end

end
function BAB:UnitAura(punit, pindex, ptype)
if BAB.DB.CurrentAurasTable[ptype][pindex] then
	local name, rank, texture, count, debuffType, duration, expirationTime, caster, isStealable, shouldConsolidate, spellId = BAB.DB.CurrentAurasTable[ptype][pindex].name, BAB.DB.CurrentAurasTable[ptype][pindex].rank, BAB.DB.CurrentAurasTable[ptype][pindex].texture, BAB.DB.CurrentAurasTable[ptype][pindex].count, BAB.DB.CurrentAurasTable[ptype][pindex].debuffType,	BAB.DB.CurrentAurasTable[ptype][pindex].duration, BAB.DB.CurrentAurasTable[ptype][pindex].expirationTime, BAB.DB.CurrentAurasTable[ptype][pindex].caster, BAB.DB.CurrentAurasTable[ptype][pindex].isStealable, BAB.DB.CurrentAurasTable[ptype][pindex].shouldConsolidate, BAB.DB.CurrentAurasTable[ptype][pindex].spellId

	return name, rank, texture, count, debuffType, duration, expirationTime, caster, isStealable, shouldConsolidate, spellId
	--return table.unpack(BAB.DB.CurrentAurasTable[ptype][pindex])
	end
end


function BAB:UnitAuraTableUpdate()
	BAB.DB.CurrentAurasTable["HELPFUL"] = {}
	BAB.DB.CurrentAurasTable["HARMFUL"] = {}

	for x = 1, BAB.DB.Settings.maxBuffsToQuery do
		local name, rank, texture, count, debuffType, duration, expirationTime, caster, isStealable, shouldConsolidate, spellId = UnitAura("player", x, "HELPFUL")
		if name then
			BAB.DB.CurrentAurasTable["HELPFUL"][x] = {
				name = name, 
				rank = rank, 
				texture = texture, 
				count = count, 
				debuffType = debuffType, 
				duration = duration, 
				expirationTime = expirationTime, 
				caster = caster, 
				isStealable = isStealable, 
				shouldConsolidate = shouldConsolidate, 
				spellId = spellId,
				x = x,
				}
		end
	end

		-- dur
	if BAB.DB.GlobalSettings.buffSort == 3 then
		table.sort(BAB.DB.CurrentAurasTable["HELPFUL"], function(w1, w2)
			local t1, t2 = w1.duration, w2.duration 
			if t1 == 0 then t1 = 99999 end
			if t2 == 0 then t2 = 99999 end
		 
			if t1 < t2 then
				return true
			else
				return false
			end
		end)
	elseif BAB.DB.GlobalSettings.buffSort == 4 then
		table.sort(BAB.DB.CurrentAurasTable["HELPFUL"], function(w1, w2)
			local t1, t2 = w1.duration, w2.duration 
			if t1 == 0 then t1 = 99999 end
			if t2 == 0 then t2 = 99999 end
		 
			if t1 > t2 then
				return true
			else
				return false
			end
		end)
		--rem
	elseif BAB.DB.GlobalSettings.buffSort == 1 then
		table.sort(BAB.DB.CurrentAurasTable["HELPFUL"], function(w1, w2)
			local t1, t2 = w1.expirationTime, w2.expirationTime 
			if t1 == 0 then t1 = GetTime() + 99999 end
			if t2 == 0 then t2 = GetTime() + 99999 end
		
			if t1 < t2 then
				return true
			else
				return false
			end
		end)
	elseif BAB.DB.GlobalSettings.buffSort == 2 then
		table.sort(BAB.DB.CurrentAurasTable["HELPFUL"], function(w1, w2)
			local t1, t2 = w1.expirationTime, w2.expirationTime 
			if t1 == 0 then t1 = GetTime() + 99999 end
			if t2 == 0 then t2 = GetTime() + 99999 end

			if t1 > t2 then
				return true
			else
				return false
			end
		end)
		--name
	elseif BAB.DB.GlobalSettings.buffSort == 5 then
		table.sort(BAB.DB.CurrentAurasTable["HELPFUL"], function(w1, w2)
			local t1, t2 = w1.name, w2.name 
		 
			if t1 < t2 then
				return true
			else
				return false
			end
		end)
	elseif BAB.DB.GlobalSettings.buffSort == 6 then
		table.sort(BAB.DB.CurrentAurasTable["HELPFUL"], function(w1, w2)
			local t1, t2 = w1.name, w2.name 
		 
			if t1 > t2 then
				return true
			else
				return false
			end
		end)
	end


	for x = 1, BAB.DB.Settings.maxDebuffsToQuery do
		local name, rank, texture, count, debuffType, duration, expirationTime, caster, isStealable, shouldConsolidate, spellId = UnitAura("player", x, "HARMFUL")
		if name then
			BAB.DB.CurrentAurasTable["HARMFUL"][x] = {
				name = name, 
				rank = rank, 
				texture = texture, 
				count = count, 
				debuffType = debuffType, 
				duration = duration, 
				expirationTime = expirationTime, 
				caster = caster, 
				isStealable = isStealable, 
				shouldConsolidate = shouldConsolidate, 
				spellId = spellId,
				x = x,
				}
		end
	end
		-- dur
	if BAB.DB.GlobalSettings.debuffSort == 3 then
		table.sort(BAB.DB.CurrentAurasTable["HARMFUL"], function(w1, w2)
			local t1, t2 = w1.duration, w2.duration 
			if t1 == 0 then t1 = 99999 end
			if t2 == 0 then t2 = 99999 end
		 
			if t1 < t2 then
				return true
			else
				return false
			end
		end)
	elseif BAB.DB.GlobalSettings.debuffSort  == 4 then
		table.sort(BAB.DB.CurrentAurasTable["HARMFUL"], function(w1, w2)
			local t1, t2 = w1.duration, w2.duration 
			if t1 == 0 then t1 = 99999 end
			if t2 == 0 then t2 = 99999 end
		 
			if t1 > t2 then
				return true
			else
				return false
			end
		end)
		--rem
	elseif BAB.DB.GlobalSettings.debuffSort  == 1 then
		table.sort(BAB.DB.CurrentAurasTable["HARMFUL"], function(w1, w2)
			local t1, t2 = w1.expirationTime, w2.expirationTime 
			if t1 == 0 then t1 = GetTime() + 99999 end
			if t2 == 0 then t2 = GetTime() + 99999 end
		
			if t1 < t2 then
				return true
			else
				return false
			end
		end)
	elseif BAB.DB.GlobalSettings.debuffSort  == 2 then
		table.sort(BAB.DB.CurrentAurasTable["HARMFUL"], function(w1, w2)
			local t1, t2 = w1.expirationTime, w2.expirationTime 
			if t1 == 0 then t1 = GetTime() + 99999 end
			if t2 == 0 then t2 = GetTime() + 99999 end

			if t1 > t2 then
				return true
			else
				return false
			end
		end)
		--name
	elseif BAB.DB.GlobalSettings.debuffSort  == 5 then
		table.sort(BAB.DB.CurrentAurasTable["HARMFUL"], function(w1, w2)
			local t1, t2 = w1.name, w2.name 
		 
			if t1 < t2 then
				return true
			else
				return false
			end
		end)
	elseif BAB.DB.GlobalSettings.debuffSort  == 6 then
		table.sort(BAB.DB.CurrentAurasTable["HARMFUL"], function(w1, w2)
			local t1, t2 = w1.name, w2.name 
		 
			if t1 > t2 then
				return true
			else
				return false
			end
		end)
	end


end