--[[--------------------------------------------------------------------------------
Copyright (c) Ulf Dornheck Busscher (Duugu) <duugu@duugu.com>
All rights reserved.
----------------------------------------------------------------------------------]]
local _, BAB = ...

--temp hack until talent specs handling is added
currentTalentSpec = 1 

-- global constants
BABAURAS_CONST_CIRCLE = 1
BABAURAS_CONST_LINE = 2
BABAURAS_CONST_BUTTON_SHAPE_STATIC = 1
BABAURAS_CONST_BUTTON_SHAPE_DYNAMIC = 2
BABAURAS_CONST_BUTTON_SHAPE_ROUND = 3




function BABAurasReset()
	BABAurasCurrentProfile = nil
	BABAurasPerCharacterBarData = {}
	BABAurasProfiles = {}
	BABAurasProfilesCharacter = {}

	BAB.Skins = {}

	BABAurasOptionSettings = {
		MainOptions = {
			headerColor = {r = 1, g = 1, b = 0.5, a = 1},
			frame = nil,
			posX = 0, posY = 800,
			width = 200, height = 400,
			},
		BarOptions = {
			frame = nil,
			posX = 200, posY = 500,
			width = 260, height = 300,
			},
		}
	BAB.DB = {
		NewVersion = BABAURAS_MAJOR_VERSION.."."..BABAURAS_MINOR_VERSION,
		InCombatLockdown = false,
		GlobalSettings = {
			ShowCurveProgression = 1,
			BuffFillDirection = 1,
			DebuffFillDirection = 1,
			EnchantFillDirection = 1,
			numberBuffBars = 1,
			numberDebuffBars = 1,
			buffSort = 2,
			debuffSort = 1,
			}, 
		Bars = {}, 
		Settings = {
			SingleDrawLineLenght = 40,
			BernsteinPoints = 4000,
			BezierPoints = 1000,
			VectorLineColor = {a = 1, r = .0, g = .0, b = 1},
			CooldownUpdateRate = 0.1,
			CooldownTextureAlpha = 0.6,
			BarWidth = 440,
			BarHeight = 38,
			BarScale = 1,
			BarColor = {r = 1, g = 1, b = 1, a = 0.3}, 
			BarColorSelected = {r = 1, g = 1, b = 1, a = 0.8}, 
			buttonPadding = 0,
			buttonShapes = {
				[1] = BAB.L["Static"], 
				[2] = BAB.L["Dynamic"], 
				[3] = BAB.L["Round"]
			},
			calcStyles = {
				[1] = BAB.L["Bezier"], 
				[2] = BAB.L["Bernstein"], 
			},
			sortStyles = {
				[1] = BAB.L["Remaining Time ASC"], 
				[2] = BAB.L["Remaining Time DESC"], 
				[3] = BAB.L["Duration ASC"], 
				[4] = BAB.L["Duration DESC"], 
				[5] = BAB.L["Name ASC"], 
				[6] = BAB.L["Name DESC"]
			}, 
			defaultBarBackdropTexture = "",--"Interface\\AddOns\\BABAuras\\Textures\\BarBackdrop",
			defaultBarBackdropColor= {r = 0.2, g = 0.2, b = 0.2, a = 1},
			requiredTexturePackVersion = 2,
			applyPortaitOn = {"Icon",},
			minLineLengthForReShape = 30,
			maxSections = 8,
			buttonMaxWidth = 90,
			buttonMinWidth = 15,
			buttonMaxPadding = 20,
			buttonMinPadding = -20,
			maxBuffsToQuery = 32,
			maxDebuffsToQuery = 32,
			baseButtonWith = 35,
			showBorder = 1,
			showBackground = 1,
			showFlash = 1,
			showCooldown = 1,
			},
		MainOptions = {
			MaxShapeFactor = 0.25,
			selectedBar = nil,
			configMode = false,
			},
		MasqueGroups = {},
		MasqueUpdateHack = 0,
		Updates = {},
		CancelButton = nil,
		ProtectedBuffs = {
			[48263] = true, -- DEATHKNIGHT Blood Presence
			[48266] = true, -- DEATHKNIGHT Frost Presence
			[48265] = true, -- DEATHKNIGHT Unholy Presence
			[1066]  = true, -- DRUID Aquatic Form
			[5487]  = true, -- DRUID Bear Form
			[768]   = true, -- DRUID Cat Form
			[33943] = true, -- DRUID Flight Form
			[40120] = true, -- DRUID Swift Flight Form
			[783]   = true, -- DRUID Travel Form
			[33891] = true, -- DRUID Tree of Life
			[15473] = true, -- PRIEST Shadowform
			[1784]  = true, -- ROGUE Stealth
			},
		CalculatedDirectionButtonTable = nil,
		CurrentAurasTable = {},
		}
end

BABAurasReset()